#include < amxmodx >
#include < amxmisc >
#include < engine >
#include < cstrike >

new const g_szSpawnClassnames[ CsTeams ][ ] =
{
	"",
	"info_player_deathmatch",
	"info_player_start",
	""
};

new const g_szFakeSpawnClassnames[ CsTeams ][ ] =
{
	"",
	"removed_t_spawn",
	"removed_ct_spawn",
	""
};

public plugin_init( )
{
	register_plugin( "Team Limiter", "0.0.2", "Exolent" );
	
	new pCvar_Limit = register_cvar( "team_limits", "* *" );
	
	new szLimit[ 8 ];
	get_pcvar_string( pCvar_Limit, szLimit, 7 );
	
	new szTeam[ 3 ];
	strbreak( szLimit, szTeam, 2, szLimit, 2 );
	
	new iNewLimit[ CsTeams ];
	iNewLimit[ CS_TEAM_T ] = is_str_num( szTeam ) ? str_to_num( szTeam ) : -1;
	iNewLimit[ CS_TEAM_CT ] = is_str_num( szLimit ) ? str_to_num( szLimit ) : -1;
	
	if( iNewLimit[ CS_TEAM_T ] < 0 && iNewLimit[ CS_TEAM_CT ] < 0 )
	{
		log_amx( "Setting both limits to < 0 doesn't change the team limit of either team." );
		return;
	}
	
	new bool:bSame = true;
	new iCurLimit;
	new iDiff;
	new iEntity;
	
	for( new CsTeams:iTeam = CS_TEAM_T; iTeam <= CS_TEAM_CT; iTeam++ )
	{
		if( iNewLimit[ iTeam ] < 0 )
		{
			continue;
		}
		
		iCurLimit = 0;
		iEntity = 0;
		while( ( iEntity = find_ent_by_class( iEntity, g_szSpawnClassnames[ iTeam ] ) ) )
		{
			iCurLimit++;
		}
		
		iDiff = iCurLimit - iNewLimit[ iTeam ];
		
		if( !iDiff )
		{
			continue;
		}
		
		bSame = false;
		
		if( iDiff > 0 )
		{
			// current - new > 0 = deleting
			
			iCurLimit = iDiff;
			while( iDiff > 0 )
			{
				iEntity = find_ent_by_class( -1, g_szSpawnClassnames[ iTeam ] );
				
				if( !is_valid_ent( iEntity ) )
				{
					iNewLimit[ iTeam ] += iDiff;
					
					log_amx( "There were not enough %s spawn points to remove. Only removed %i of %i.",\
						iTeam == CS_TEAM_T ? "" : "C", ( iCurLimit - iDiff ), iCurLimit );
					
					break;
				}
				
				entity_set_string( iEntity, EV_SZ_classname, g_szFakeSpawnClassnames[ iTeam ] );
				
				iDiff--;
			}
		}
		else
		{
			// current - new < 0 = adding
			iDiff *= -1;
			
			iCurLimit = iDiff;
			while( iDiff > 0 )
			{
				iEntity = find_ent_by_class( -1, g_szFakeSpawnClassnames[ iTeam ] );
				
				if( !is_valid_ent( iEntity ) )
				{
					iNewLimit[ iTeam ] -= iDiff;
					
					log_amx( "There were not enough %sT spawn points to restore. Only restored %i of %i.",\
						iTeam == CS_TEAM_T ? "" : "C", ( iCurLimit - iDiff ), iCurLimit );
					
					break;
				}
				
				entity_set_string( iEntity, EV_SZ_classname, g_szSpawnClassnames[ iTeam ] );
				
				iDiff--;
			}
		}
	}
	
	if( bSame )
	{
		log_amx( "The teams are already limited to this amount." );
	}
	else
	{
		log_amx( "The teams have been limited to T:%i, CT:%i", iNewLimit[ CS_TEAM_T ], iNewLimit[ CS_TEAM_CT ] );
	}
}